package cn.breeze.elleai.codegen;

import com.mybatisflex.codegen.Generator;
import com.mybatisflex.codegen.config.GlobalConfig;
import com.zaxxer.hikari.HikariDataSource;

/**
 * 代码生成器
 * 通过连接数据库，生成代码，只生成entity
 *
 */

public class CodeGen {

    public static void main(String[] args) {

        //配置数据源
        HikariDataSource dataSource = new HikariDataSource();
        dataSource.setJdbcUrl("jdbc:mysql://172.18.5.186:4306/ellehuis?characterEncoding=utf-8&useSSL=false");
        dataSource.setUsername("future");
        dataSource.setPassword("future123456");
        GlobalConfig globalConfig = createGlobalConfigUseStyle1();
        Generator generator = new Generator(dataSource, globalConfig);
        generator.generate();
    }

    public static GlobalConfig createGlobalConfigUseStyle1() {
        //创建配置内容
        GlobalConfig globalConfig = new GlobalConfig();

        globalConfig.setAuthor("breeze");

        //设置根包
        globalConfig.setBasePackage("cn.breeze.elleai.infra");

        //设置表前缀和只生成哪些表
        globalConfig.setTablePrefix("ai_");
        globalConfig.setGenerateTable("ai_*");

        //设置生成 entity 并启用 Lombok
        globalConfig.setEntityGenerateEnable(true);
        globalConfig.setEntityWithLombok(true);
        globalConfig.setEntityClassSuffix("Entity");
        //设置项目的JDK版本，项目的JDK为14及以上时建议设置该项，小于14则可以不设置
        globalConfig.setEntityJdkVersion(17);
        globalConfig.getEntityConfig().setOverwriteEnable(true);

        globalConfig.enableTableDef();
        globalConfig.getTableDefConfig().setOverwriteEnable(true);

        globalConfig.enableMapper();
        globalConfig.getMapperConfig().setMapperAnnotation(true);
//        globalConfig.getMapperConfig().setOverwriteEnable(true);

        globalConfig.enableService();
        globalConfig.setServicePackage("cn.breeze.elleai.domain.sparring.service");
        globalConfig.getServiceConfig().setClassSuffix("Service");
        globalConfig.getServiceConfig().setClassPrefix("I");
        globalConfig.getServiceConfig().setOverwriteEnable(true);

        globalConfig.enableServiceImpl();
        globalConfig.setServiceImplPackage("cn.breeze.elleai.domain.sparring.service");
        globalConfig.getServiceImplConfig().setClassSuffix("ServiceImpl");
        globalConfig.getServiceImplConfig().setOverwriteEnable(true);

        return globalConfig;
    }
}
